<template>
  <div id="app">
    <cookie-consent
      variant="primary2"
      decline-jump-to-href="https://www.europeandataportal.eu/cookies"
      :matomo-url="matomoURL"
    />
      <back-to-top bottom="20px" right="20px" visibleoffsetbottom="200" >
            <button type="button" class="btn btn-info btn-to-top"><i class="fa fa-angle-up" aria-hidden="true"></i></button>
          </back-to-top>
          <topnav></topnav>
       <div class="bg container">
          <subnavigation></subnavigation>
            <div class="main-content">
              <router-view></router-view>
          </div>
        <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.7.2/css/all.css" integrity="sha384-fnmOCqbTlWIlj8LyTjo7mOUStjsKC4pOpQbqyi7RrhN7udi9RwhKkMHpvLbHG9Sr" crossorigin="anonymous">
    </div>
    <bottom></bottom>
  </div>
</template>

<script>
import CookieConsent from './components/gdpr/CookieConsent'
import Topnav from './components/EDP3-header'
import Bottom from './components/EDP3-footer'
import SubNavigation from './components/SubNavigation'

export default {
  name: 'app',
  components: {
    CookieConsent,
    topnav: Topnav,
    bottom: Bottom,
    subnavigation: SubNavigation
  },
  data () {
    return {
      tracker: null,
      matomoURL: this.$env.MATOMO_URL,
      lastRoute: null
    }
  },
  watch: {
    // eslint-disable-next-line no-unused-vars
    $route: {
      immediate: true,
      handler (to, from) {
        // Help Matomo track new page views.
        // Also gets triggered on initial page load.

        // router-link somehow makes this watcher trigger twice; Once immediately after the click
        // and once after the new view has loaded.
        // This is a workaround to prevent tracking the same route full path twice.
        if (to.fullPath !== this.lastRoute) {
          // Get url
          let protocol = window.location.protocol
          if (protocol.slice(-1) !== ':') {
            protocol += ':'
          }

          const router = this.$router
          const hashMode = router.mode === 'hash' ? '/#' : ''
          // eslint-disable-next-line no-undef
          let basePath = router.options.base
          basePath = basePath.slice(-1) === '/' ? basePath.slice(0, -1) : basePath

          const url = `${protocol}//${window.location.host}${basePath}${hashMode}${to.fullPath}`

          window._paq = window._paq || []
          window._paq.push(['setCustomUrl', url])
          window._paq.push(['trackPageView'])
          this.lastRoute = to.fullPath
        }
      }
    }
  }
}
</script>

<style lang="scss">
@import './styles/metrics-style.scss';
@import '../node_modules/bootstrap/scss/bootstrap.scss';

* {
  box-sizing: border-box;
}

.site-wrapper {
  border: 1px solid #83b4c2;
  margin: auto;
  max-width: 984px;
  box-shadow: 0 2px 5px 0 rgba(0, 0, 0, 0.16), 0 2px 10px 0 rgba(0, 0, 0, 0.12);
}

.spacer {
  margin: 500px;
}

#app {
  background-color: #f3fafe;
}

.bg {
  background-color: #fff;
}

</style>
